Unit mnb6e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure mnb6e(N :Integer; NP1 :Integer; var ITMAX :Integer;
                var ALFA :Extended; var BETA :Extended; var GAM :Extended;
                var ACC :Extended; A :Extended; var X :Array of Extended;
                var XCEN :Array of Extended; var Z :Array of Extended;
                var XREF :Array of Extended; var XCON :Array of Extended;
                var XEX :Array of Extended; var XX :Array of Extended;
                var FF :Extended; var MAXK :Integer; FUN :Proc_F1E_MN;
                var IERR :Integer);

implementation

procedure mnb6e(N :Integer; NP1 :Integer; var ITMAX :Integer;
                var ALFA :Extended; var BETA :Extended; var GAM :Extended;
                var ACC :Extended; A :Extended; var X :Array of Extended;
                var XCEN :Array of Extended; var Z :Array of Extended;
                var XREF :Array of Extended; var XCON :Array of Extended;
                var XEX :Array of Extended; var XX :Array of Extended;
                var FF :Extended; var MAXK :Integer; FUN :Proc_F1E_MN;
                var IERR :Integer);
var
I,ITR,J,K,KOUNT,L :Integer;
EN,EPS,FE,Q,P,SUM,ZCEN,ZCON,ZEX,ZHI,ZREF :Extended;
const
C :Extended = 1.0e-4;
label
_100,_120,_150,_154,_155,_162,_164,_165,_175,_180,_185,_190,_200,_208,
_210,_215,_220,_222,_224,_225,_240,_245,_255,_260,_261,_270,_280,_300,
_310,_1000;
begin
{    POPAMMA EYCOBHO MHMA METOOM HEEPA-MA. }
{      APAMETP }
{      N     -PAMEPHOCT POCTPAHCTBA EPEMEHHX }
{      NP1   -PAMEPHOCT MHOOPAHHKA }
{      ITMAX -MAKCMAHOE CO TEPA }
{      ALFA  -APAMETP OTPAEH }
{      BETA  -APAMETP CAT }
{      GAM   -APAMETP PACTEH }
{      ACC   -TOHOCT BCEH }
{      A     -PAMEP CXOHOO MHOOPAHHKA }
{      X,XCEN,Z,XREF,XCON,XEX-PAOE MACCB }
{      XX    -HA BXOE-HAAHA TOKA OCKA, }
{             HA BXOE-TOKA MHMYMA }
{      FF    -MHMAHOE HAEHE YHK }
{      MAXK  -MAKCMAHOE CO BC. YHK }
{      FUN   -OPOPAMMA BCEH YHK }
{      IERR  -PHAK OKOHAH OCKA }
L := 0;
ITR := 0;
KOUNT := 0;
Q := (A/(N*Sqrt(2.e0)))*(Sqrt(N+1.e0)-1.e0);
P := (A/(N*Sqrt(2.e0)))*(Sqrt(N+1.e0)+N-1.e0);
{   OCTPOEHE HAAHOO CMEKCA }
for J:=1 to N do
 begin
_100:
  X[0+(J-1)*NP1] := XX[J-1];
 end;
for I:=2 to NP1 do
 begin
  for J:=1 to N do
   begin
    X[(I-1)+(J-1)*NP1] := X[0+(J-1)*NP1]+Q;
    if ( I-1 = J ) 
     then X[(I-1)+(J-1)*NP1] := X[0+(J-1)*NP1]+P;
_120:
   end;
 end;
if ( ALFA = 0.e0 ) 
 then ALFA := 1.e0;
if ( BETA = 0.e0 ) 
 then BETA := 5.e-1;
if ( GAM = 0.e0 ) 
 then GAM := 2.e0;
if ( ACC = 0.e0 ) 
 then ACC := C;
{   HAAO TEPA }
_150:
for I:=1 to NP1 do
 begin
  if ( I = L ) 
   then goto _155;
  for J:=1 to N do
   begin
_154:
    XX[J-1] := X[(I-1)+(J-1)*NP1];
   end;
  FUN(XX,Z[I-1],FE);
  KOUNT := KOUNT+1;
_155:
 end;
_162:
ITR := ITR+1;
if ( ITR > ITMAX ) 
 then goto _270;
if ( KOUNT > MAXK ) 
 then goto _280;
ZHI := Z[0];
FF := Z[0];
K := 1;
L := 1;
for I:=2 to NP1 do
 begin
  if ( ZHI >= Z[I-1] ) 
   then goto _164;
  ZHI := Z[I-1];
  K := I;
_164:
  if ( FF <= Z[I-1] ) 
   then goto _165;
  FF := Z[I-1];
  L := I;
_165:
 end;
{   EHTPO }
EN := N;
for J:=1 to N do
 begin
  SUM := 0.e0;
  for I:=1 to NP1 do
   begin
    if ( K = I ) 
     then goto _175;
    SUM := SUM+X[(I-1)+(J-1)*NP1];
_175:
   end;
_180:
  XCEN[J-1] := SUM/EN;
 end;
FUN(XCEN,ZCEN,FE);
KOUNT := KOUNT+1;
SUM := 0.e0;
for I:=1 to NP1 do
 begin
  if ( K = I ) 
   then goto _185;
  SUM := SUM+(Z[I-1]-ZCEN)*(Z[I-1]-ZCEN)/EN;
_185:
 end;
EPS := Sqrt(SUM);
if ( EPS < ACC ) 
 then goto _261;
{   OTPAEHE }
for J:=1 to N do
 begin
_190:
  XREF[J-1] := XCEN[J-1]+ALFA*(XCEN[J-1]-X[(K-1)+(J-1)*NP1]);
 end;
FUN(XREF,ZREF,FE);
KOUNT := KOUNT+1;
if ( ZREF <= Z[L-1] ) 
 then goto _240;
for I:=1 to NP1 do
 begin
  if ( ZREF < Z[I-1] ) and ( I <> K ) 
   then goto _208;
_200:
 end;
goto _215;
_208:
for J:=1 to N do
 begin
_210:
  X[(K-1)+(J-1)*NP1] := XREF[J-1];
 end;
Z[K-1] := ZREF;
goto _162;
{   CATE }
_215:
for J:=1 to N do
 begin
_220:
  XCON[J-1] := XCEN[J-1]+BETA*(X[(K-1)+(J-1)*NP1]-XCEN[J-1]);
 end;
FUN(XCON,ZCON,FE);
KOUNT := KOUNT+1;
if ( ZCON >= Z[K-1] ) 
 then goto _224;
for J:=1 to N do
 begin
_222:
  X[(K-1)+(J-1)*NP1] := XCON[J-1];
 end;
Z[K-1] := ZCON;
goto _162;
{   PEYK }
_224:
for J:=1 to N do
 begin
  for I:=1 to NP1 do
   begin
_225:
    X[(I-1)+(J-1)*NP1] := (X[(I-1)+(J-1)*NP1]+X[(L-1)+(J-1)*NP1])/2.e0;
   end;
 end;
goto _150;
{   PACTEHE }
_240:
for J:=1 to N do
 begin
_245:
  XEX[J-1] := XCEN[J-1]+GAM*(XREF[J-1]-XCEN[J-1]);
 end;
FUN(XEX,ZEX,FE);
KOUNT := KOUNT+1;
if ( ZEX < Z[L-1] ) 
 then goto _255;
goto _208;
_255:
for J:=1 to N do
 begin
_260:
  X[(K-1)+(J-1)*NP1] := XEX[J-1];
 end;
Z[K-1] := ZEX;
goto _162;
{   B  X O  }
_261:
IERR := 1;
goto _300;
_270:
IERR := 65;
ITR := ITR-1;
goto _300;
_280:
IERR := 66;
_300:
for J:=1 to N do
 begin
_310:
  XX[J-1] := X[(L-1)+(J-1)*NP1];
 end;
MAXK := KOUNT;
ITMAX := ITR;
_1000:
end;

end.
